#include <fstream>
#include <iostream>

using namespace std;

const int MAX_N = 100000;
int n;
int A[MAX_N + 1];	//la numerazione delle celle deve partire da 1
int Sum[MAX_N + 1];

void updateSum(int j, int q){
	for(int i = j; i <= n; i++)
		Sum[i] = Sum[i] + q;
}

void update(int q, int i){
	if(i > 0 && i <= n){
		A[i] = A[i] + q;
		updateSum(i, q);
	}
}


int main(){

	int op, q, s, e, u, qr, nu; // numero di operazioni, tipo di operazione, start, end, nuovo elemento, risultato query, numero update eseguiti
  ifstream in("input.txt");
  in >> n;
	in >> op;
  if(op == 0) in.close();	//non ci sono query
	else{
		for(int i = 0; i <= n; i++) A[i] = 0;	//metto a zero gli elementi del vettore
		for(int i = 0; i <= n; i++) Sum[i] = 0;	//metto a zero le somme
		nu = 0;	//metto a zero gli update

		ofstream out("output.txt");
		for(int i = 0; i < op; i++){	
			in >> q;
			if(q == 0){
				qr = 0;
				in >> s;
				in >> e;
				if( s > 0 && s <= n && e > 0 && e <= n && s <= e){
					if(nu == 0) qr = 0;	//se non ho fatto update tutti gli elementi sono zero quindi anche le somme lo sono
					else{
						if(s == e) qr = A[s];	//prendo l'elemento direttamente da A
						else{
							if( s == 1) qr = Sum[e];	//voglio tutti gli elementi dal primo fino ad e
							else qr = Sum[e] - Sum[s - 1];	//prendo la somma di tutti gli elementi da 1 a e e poi tolgo la somma di quelli prima di s
						}
					}
				}
				out << qr << " ";
			}
		
			if(q != 0){
				in >> u;
				update(q, u);
				nu++;
			}
		}
		out.close();
		in.close();
	}
  return 0;
}
