#include <cstdlib>
#include <fstream>
#include <iostream>
#include <string.h>

using namespace std;

#define max(a,b) (  ((a) > (b)) ? (a) : (b))

int M[128][128];
int M2[128][128];


void LCS(int Matrix[128][128], char* A, char* B, int n,int m) {
	for (int i=1; i < n; i++) {
		for (int j=1; j < m; j++)
			Matrix[i][j] = A[i] == B[j] ? 1 + Matrix[i-1][j-1] : max(Matrix[i-1][j], Matrix[i][j-1]);
	}
}

char* printLCS(int Matrix[128][128], char* A, char* B, int n ,int m) {
	int i = n-1;
	int j = m-1;
	char lcs[128];
	lcs[Matrix[i][j]] = '\0';
	int k = Matrix[i][j] -1;
	while (k >= 0) {
		if (A[i] == B[j]) {
			lcs[k] = A[i];
			i--; j--; k--;
		} else {
			if (i== 0)
				j--;
			else if (j == 0)
				i--;
			else if (Matrix[i-1][j-1] == Matrix[i][j]) {
				i--;
				j--;
			} else if (Matrix[i-1][j] == Matrix[i][j])
				i--;
			else
				j--;
		}
	}
	//printf("%s\n", lcs);
	return lcs;
}

void display(int Matrix[128][128], int n, int m) {
	cout << endl;
	for (int i=0; i < n; i++) {
		for (int j=0; j < m; j++)
			cout << Matrix[i][j] << " ";
		cout << endl;
	} 
	cout << endl << endl;
}

ofstream fout("output.txt");

void init(int Matrix[128][128], char* A, char* B, int n ,int m) {
	for (int i= 0; i < n; i ++) {
		if (A[0] == B[i])
			while (i <n) {
				Matrix[i][0] = 1;
				i++;
			}
	}

	for (int j= 0; j < m; j++) {
		if (A[j] == B[0])
			while (j <m) {
				Matrix[0][j] = 1;
				j++;
			}
	}
}

int main(int argc, char** argv) {
	FILE* fin = fopen("input.txt", "r");
	
	char StringA[100];
	char StringB[100];
	char StringC[100];

	int n,m,o;
	fscanf(fin, "%d %d %d", &n,&m,&o);

	fscanf(fin, "%s", StringA);
	fscanf(fin, "%s", StringB);
	fscanf(fin, "%s", StringC);

	init(M, StringA, StringB, n, m);
	LCS(M, StringA, StringB, n, m);
	char* lcs = printLCS(M, StringA, StringB, n, m);
	
	init(M2, lcs, StringC, M[n-1][m-1], o);
	LCS(M2, lcs, StringC, M[n-1][m-1], o);
	
	fout << M2[ M[n-1][m-1]-1 ][ o-1 ];
	
	return EXIT_SUCCESS;
}
