#include<stdio.h>
#include<assert.h>

void main(){
	int n,m;	//n è il numero di elementi, m è il numero di query
	int array[100000];	//creo un array di dimensione massima
	FILE *F1 = fopen("input.txt","r");
	fscanf(F1,"%d %d",&n,&m);	//leggo n ed m
	assert(n<=100000);
	assert(m<=100000);
	
	FILE *F2=fopen("output.txt","w");
	
	int i;
	for(i=0;i<n;i++){
		array[i]=0;		//inizializzo la parte indicata di array a 0
	}

	int v1,v2,v3;
	for(i=0;i<m;i++){	//itero le richieste
		fscanf(F1,"%d",&v1);	//leggo il primo valore della riga
		assert(v1>-10);
		assert(v1<10);
		if(v1==0) {		//è una query
			fscanf(F1,"%d %d",&v2,&v3);	//leggo il secondo ed il terzo valore della riga
			assert(v2>0);
			assert(v2<=n);
			assert(v3>0);
			assert(v3<=n);
			int j,sum;
			sum=0;
			if (v2==v3){	//restituisco un solo elemento
				fprintf(F2,"%d ",array[v2-1]);
			}
			else{
				for(j=(v2-1);j<v3;j++){
					sum+=array[j];
				}
				fprintf(F2,"%d ",sum);
			}
		}
		else{		//è un update
			fscanf(F1,"%d",&v2);	//leggo il primo valore della riga
			assert(v2>0);
			assert(v2<=n);
			array[v2-1]+=v1;
		}
	}

	fclose(F1);
	fclose(F2);
}
//VR364760 Pagliarini Marco
